<?php
declare (strict_types=1);

namespace App\Entity\Billing;

use ApiPlatform\Metadata\Get;
use ApiPlatform\Metadata\ApiResource;
use App\Entity\Product\EquipmentLoan;
//use DH\Auditor\Provider\Doctrine\Auditing\Annotation\Auditable;
use Doctrine\ORM\Mapping as ORM;

/**
 * Classe ... qui ...
 */
#[ApiResource(
    operations: [
        new Get(
            security: 'is_granted(\'ROLE_ADMIN\')'
        )
    ]
)]
//#[Auditable]
#[ORM\Entity]
class BillingIntangibleExcludeDate
{
    #[ORM\Id]
    #[ORM\Column]
    #[ORM\GeneratedValue]
    private ?int $id = null;

    #[ORM\ManyToOne(cascade: ['persist'], inversedBy: 'billingIntangibleExcludeDates')]
    private AccessIntangible $accessIntangible;

    #[ORM\ManyToOne(cascade: ['persist'], inversedBy: 'billingIntangibleExcludeDates')]
    private AccessFictionalIntangible $accessFictionalIntangible;

    #[ORM\ManyToOne(cascade: ['persist'], inversedBy: 'billingIntangibleExcludeDates')]
    private EducationalProjectIntangible $educationalProjectIntangible;

    #[ORM\ManyToOne(cascade: ['persist'], inversedBy: 'billingIntangibleExcludeDates')]
    private EquipmentLoan $equipmentLoan;

    #[ORM\ManyToOne(cascade: ['persist'], inversedBy: 'billingIntangibleExcludeDates')]
    private Bill $bill;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getAccessIntangible(): ?AccessIntangible
    {
        return $this->accessIntangible;
    }

    public function setAccessIntangible(?AccessIntangible $accessIntangible): self
    {
        $this->accessIntangible = $accessIntangible;
        return $this;
    }

    public function getAccessFictionalIntangible(): ?AccessFictionalIntangible
    {
        return $this->accessFictionalIntangible;
    }

    public function setAccessFictionalIntangible(?AccessFictionalIntangible $accessFictionalIntangible): self
    {
        $this->accessFictionalIntangible = $accessFictionalIntangible;
        return $this;
    }

    public function getEducationalProjectIntangible(): ?EducationalProjectIntangible
    {
        return $this->educationalProjectIntangible;
    }

    public function setEducationalProjectIntangible(?EducationalProjectIntangible $educationalProjectIntangible): self
    {
        $this->educationalProjectIntangible = $educationalProjectIntangible;
        return $this;
    }

    public function getEquipmentLoan(): ?EquipmentLoan
    {
        return $this->equipmentLoan;
    }

    public function setEquipmentLoan(?EquipmentLoan $equipmentLoan): self
    {
        $this->equipmentLoan = $equipmentLoan;
        return $this;
    }

    public function getBill(): ?Bill
    {
        return $this->bill;
    }

    public function setBill(?Bill $bill): self
    {
        $this->bill = $bill;
        return $this;
    }
}
